"""Code from lecture 18 - tuples"""

import random

#some_extras()
	
def get_choice():
	print()
	print("  1. Slide 4 - Show tuple examples")
	print("  2. Slides 6 & 7 - Print a tuple, access the elements of a tuple")
	print("  3. Slides 8 to 10 - in, is, equality, repeat, slicing")
	print("  4. Slide 11 - Pass a tuple as a parameter - fiddle_tuples() ")
	print("  5. Slide 12 to 14 - convert list-tuple, tuple-list, multiple assignment")
	print("  6. Slide 15 - Return a tuple, get_a_date()")
	print("  7. Slide 16 - index function with tuple") 
	print("  8. Slide 17 - get_uniques_tuple()")
	print("  9. Slide 18 - carry_out_transactions()")
	print("  10. Extra stuff - some_extras()")
	print("  0. Exit")
	selection = int(input("  Enter selection: "))
	print()
	return selection
	
def main():
	selection = 1
	print()
	
	while selection > 0:
		selection = get_choice()
		print('*' * 40)
		if selection == 1:
			slide04() 
		elif selection == 2:
			slides6_and_7()
		elif selection == 3:
			slides8_to_10() 
		elif selection == 4:
			slide11() 
		elif selection == 5:
			slides12_to_14()  
		elif selection == 6:
			slide15()
		elif selection == 7:
			slide16()	
		elif selection == 8:
			slide17()
		elif selection == 9:
			slide18()
		elif selection == 10:
			some_extras()
		print('*' * 40)

def fiddle_tuples(t1, t2):
	t3 = (t1[1], t2[0])
	t1 = (t3[1], t2[0])
	t2 = t1
	return t3
	
def slide11():
	print("Slide 11")
	t1 = (3, 5)
	t2 = (4, 7)
	t3 = t2
	t3 = fiddle_tuples(t1, t2)
	print("t1:", t1, "t2:", t2, "t3:", t3)

    
#Slide 15 get_a_date()
def get_a_date():
    months = ("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December")
    days_in_month = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)
    days = ("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday")
    day_number = random.randrange(0, len(days))	
    month_number = random.randrange(0, len(months))
    date = random.randrange(1, days_in_month[month_number] + 1)
    return (days[day_number], months[month_number], date)

def slide15():
    print("Slide 15")
    date = get_a_date()	
    print("Your best day next year is a", date[0],  "around", date[1], date[2])
    date = get_a_date()	
    print("Next year be careful on a", date[0],  "around", date[1], date[2])
    print()
#-----------------------------
#-----------------------------
#Slide 17 get_uniques_tuple()
def get_uniques_tuple(a_tuple):
    a_list = []
    for element in a_tuple:
         if not element in a_list:
             a_list.append(element)
    return tuple(a_list)

def slide17():
    print("Slide 17")
    a_tuple = get_uniques_tuple((3, 4, 5, 6, 3, 2, 9, 4, 5, 6, 2, 9))
    print("No duplicates", a_tuple)
    print()
#-----------------------------
#-----------------------------
#Slide 18 carry_out_transactions()
def carry_out_transactions(balance, transactions_tuple):
    withdrawals = 0
    deposits = 0
    for trans in transactions_tuple:
            if trans < 0:
                    withdrawals += abs(trans)
            elif trans > 0:
                    deposits += trans

            balance += trans
    return (balance, deposits, withdrawals)
            
                    
def slide18():
    print("Slide 18")
    results = carry_out_transactions(5400, (100, -400, 500, -800, 600, -100, - 200, 50, 0, -200))
    print("Balance $", results[0], ", deposits $", results[1], ", withdrawals $", results[2], sep="")
    print()
#-----------------------------
#-----------------------------
def slide04():
    print("Slide 4:")
    tuple1 = (4, True, "Test", 34.8)
    tuple2 = ("red", "blue")
    tuple3 = (1, 2, "jim")
    tuple4 = (3,) 
    print(len(tuple1), "tuple1", tuple1)
    print(len(tuple2), "tuple2", tuple2)
    print(len(tuple3), "tuple3", tuple3)
    print(len(tuple4), "tuple4", tuple4)
    

def slides6_and_7():
    print("Slides 6_and_7:")
    tuple1 = (3, 6, 8)
    print(tuple1)

    tuple2 = ("abcdef", "ghij", "klmno")
    print(tuple2)
    tuple1 = (3, 6, 8)
    print(tuple1[1], tuple1[2], tuple1[0])
    print(tuple1[-2], tuple1[-3])

    tuple2 = (tuple1[1], tuple1[2], tuple1[0], 1, 7)
    print(tuple2)

    for element in tuple2:
            if element > 3:
                    print(element)
    print()

def slides8_to_10():
    print("Slides 8_to_10:")
    tuple1 = (3, 6, 8)
    tuple2 = (5, 1, 0, 4)
    tuple3 = tuple2 + tuple1
    tuple4 = tuple1 * 3

    print(0 in tuple1)
    print(0 in tuple2)

    print(1, tuple1)
    print(2, tuple2)
    print(3, tuple3)
    print(4, tuple4)
    print()
    tuple1 = (3, 6, 8, 0, 1, 2, 7)
    print(tuple1[0:6:2])
    print(tuple1[2:7:3])
    print(tuple1[5:1:-1])
    print()
    tuple1 = (3, 6, 8)
    tuple2 = tuple1
    tuple3 = (tuple2[0], tuple2[1], tuple2[2])

    print('1.', tuple1 is tuple2)

    tuple1 = tuple1 + (5,)

    print('2.', tuple1)
    print('3.', tuple2)

    print('4.', tuple1 is tuple2)
    print('5.', tuple2 == tuple3)
    print('6.', tuple2 is tuple3)
    
def slides12_to_14():
    print("Slides 12_to_14:")
    tuple1 = (3, 6, 8, 2, 5)
    a_list = list(tuple1)
    a_list.sort()

    print(tuple1)
    print(a_list)

    print()
    tuple1 = (3, 6, 8, 2, 5)
    a_list = list(tuple1)
    a_list.sort()
    a_tuple = tuple(a_list)

    print('1.', a_list)
    print('2.', tuple1)
    print('3.', a_tuple)

    print()	
    scores = (56, 78, 91)
    (test1, test2, test3) = scores  #or test1, test2, test3 = scores
    name1, name2, name3 = "Bob", "Jane", "Jill"
    name2 = name2 + "-marie"

    print(test2, test1, test3)
    print(name3, name1, name2)	

    
def slide16():
    print("Slide 16")
    tuple1 = (10, 20, 30, 40, 50, 55)
    if 40 in tuple1:			#check first
            position = tuple1.index(40)
            print("40 is in position", position, "in the tuple")
    else:
            print("40 is not in the tuple")
 
def get_results():
    return (4, 6, 2)

def some_extras():
	tuple0 = tuple()
	print(tuple0, type(tuple0))
	print()
	tuple1 = tuple(("red", "blue")) 
	print(tuple1)

	tuple1 = (5, 7, 2, 6, 4, 3, 9) 
	tuple2 = (6, )
	print("Elements in tuple1")
	for element in tuple1:
	     print(element)
	print()
	number_of_elements = len(tuple1) 
	min_value = min(tuple1) 
	max_value = max(tuple1) 
	total = sum(tuple1) 
	print()
	element_from_end = tuple1[-2]
	tuple2 = tuple1[1:5:2]
	position = tuple1.index(3) 
	tuple3 = tuple([8, 4, 9])
	list1 = list(tuple1)
	print()
	(a, b, c) = ("ant", "bee", "cat")
	print(1, min_value)
	print(2, max_value)
	print(3, total)
	print(4, element_from_end)
	print(5, tuple2)	
	print(6, position)
	print(7, list1)
	print(7, a, b, c)
	print(9, get_results())
	
	aword = 'jk jk kj'
	print("string index and find:", aword.index('k'), aword.find('k'))
	alist = aword.split()
	print(alist.index('kj'))
	#print(alist.find('jk')) #find is not a method which can be applied to list objects

main()

"""

"""
