"""Code from lecture 18 - tuples"""

import random
def get_choice():
	print()
	print("  1. Slide 11 - Pass a tuple as a parameter - fiddle_tuples() ")
	print("  2. Slide 15 - Return a tuple, get_a_date()")
	print("  3. Slide 17 - get_uniques_tuple(")
	print("  4. Slide 18 - carry_out_transactions()")
	print("  0. Exit")
	selection = int(input("  Enter selection: "))
	print()
	return selection
	
def main():
	selection = 1
	print()
	
	while selection > 0:
		selection = get_choice()
		print('*' * 40)
		if selection == 1:
			slide11() 
		elif selection == 2:
			slide15()
		elif selection == 3:
			slide17() 
		elif selection == 4:
			slide18()	
		print('*' * 40)

def fiddle_tuples(t1, t2):
	t3 = (t1[1], t2[0])
	t1 = (t3[1], t2[0])
	t2 = t1
	return t3
	
def slide11():
	print("Slide 11: fiddle_tuples()")
	t1 = (3, 5)
	t2 = (4, 7)
	t3 = t2
	t3 = fiddle_tuples(t1, t2)
	print("t1:", t1, "t2:", t2, "t3:", t3)

    
#Slide 15 get_a_date()
def get_a_date():
    months = ("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December")
    days_in_month = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)
    days = ("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday")
    day_number = random.randrange(0, len(days))	
    month_number = random.randrange(0, len(months))
    date = random.randrange(1, days_in_month[month_number] + 1)
    return (days[day_number], months[month_number], date)

def slide15():
    print("Slide 13:")
    date = get_a_date()	
    print("Your best day next year is a", date[0],  "around", date[1], date[2])
    date = get_a_date()	
    print("Next year be careful on a", date[0],  "around", date[1], date[2])
#-----------------------------
#-----------------------------
#Slide 17 get_uniques_tuple()
def get_uniques_tuple(a_tuple):
    a_list = []
    for element in a_tuple:
         if not element in a_list:
             a_list.append(element)
    return tuple(a_list)

def slide17():
    print("Slide 17:")
    a_tuple = get_uniques_tuple((3, 4, 5, 6, 3, 2, 9, 4, 5, 6, 2, 9))
    print("No duplicates", a_tuple)
#-----------------------------
#-----------------------------
#Slide 18 carry_out_transactions()
def carry_out_transactions(balance, transactions_tuple):
	withdrawals = 0
	deposits = 0
	for trans in transactions_tuple:
		if trans < 0:
			withdrawals = withdrawals + abs(trans)
		elif trans > 0:
			deposits = deposits + trans

		balance = balance + trans
	return (balance, deposits, withdrawals)

def slide18():
    print("Slide 18:")
    results = carry_out_transactions(5400, (100, -400, 500, -800, 600, -100, - 200, 50, 0, -200))
    print("Balance $", results[0], ", deposits $", results[1], ", withdrawals $", results[2], sep="")

main()